## AgsModularSynthUtil

AgsModularSynthUtil — frequency modulation synth util

## Stability Level

Stable, unless otherwise indicated

## Functions

AgsModularSynthUtil * | ags_modular_synth_util_alloc ()
gpointer | ags_modular_synth_util_copy ()
void | ags_modular_synth_util_free ()
gpointer | ags_modular_synth_util_get_source ()
void | ags_modular_synth_util_set_source ()
guint | ags_modular_synth_util_get_source_stride ()
void | ags_modular_synth_util_set_source_stride ()
guint | ags_modular_synth_util_get_buffer_length ()
void | ags_modular_synth_util_set_buffer_length ()
AgsSoundcardFormat | ags_modular_synth_util_get_format ()
void | ags_modular_synth_util_set_format ()
guint | ags_modular_synth_util_get_samplerate ()
void | ags_modular_synth_util_set_samplerate ()
AgsSynthOscillatorMode | ags_modular_synth_util_get_osc_0_oscillator ()
void | ags_modular_synth_util_set_osc_0_oscillator ()
gdouble | ags_modular_synth_util_get_osc_0_frequency ()
void | ags_modular_synth_util_set_osc_0_frequency ()
gdouble | ags_modular_synth_util_get_osc_0_phase ()
void | ags_modular_synth_util_set_osc_0_phase ()
gdouble | ags_modular_synth_util_get_osc_0_volume ()
void | ags_modular_synth_util_set_osc_0_volume ()
AgsSynthOscillatorMode | ags_modular_synth_util_get_osc_1_oscillator ()
void | ags_modular_synth_util_set_osc_1_oscillator ()
gdouble | ags_modular_synth_util_get_osc_1_frequency ()
void | ags_modular_synth_util_set_osc_1_frequency ()
gdouble | ags_modular_synth_util_get_osc_1_phase ()
void | ags_modular_synth_util_set_osc_1_phase ()
gdouble | ags_modular_synth_util_get_osc_1_volume ()
void | ags_modular_synth_util_set_osc_1_volume ()
gdouble | ags_modular_synth_util_get_pitch_tuning ()
void | ags_modular_synth_util_set_pitch_tuning ()
gdouble | ags_modular_synth_util_get_volume ()
void | ags_modular_synth_util_set_volume ()
gdouble | ags_modular_synth_util_get_env_0_attack ()
void | ags_modular_synth_util_set_env_0_attack ()
gdouble | ags_modular_synth_util_get_env_0_sustain ()
void | ags_modular_synth_util_set_env_0_sustain ()
gdouble | ags_modular_synth_util_get_env_0_decay ()
void | ags_modular_synth_util_set_env_0_decay ()
gdouble | ags_modular_synth_util_get_env_0_release ()
void | ags_modular_synth_util_set_env_0_release ()
gdouble | ags_modular_synth_util_get_env_0_gain ()
void | ags_modular_synth_util_set_env_0_gain ()
gdouble | ags_modular_synth_util_get_env_0_frequency ()
void | ags_modular_synth_util_set_env_0_frequency ()
gint64 * | ags_modular_synth_util_get_env_0_sends ()
void | ags_modular_synth_util_set_env_0_sends ()
gdouble | ags_modular_synth_util_get_env_1_attack ()
void | ags_modular_synth_util_set_env_1_attack ()
gdouble | ags_modular_synth_util_get_env_1_sustain ()
void | ags_modular_synth_util_set_env_1_sustain ()
gdouble | ags_modular_synth_util_get_env_1_decay ()
void | ags_modular_synth_util_set_env_1_decay ()
gdouble | ags_modular_synth_util_get_env_1_release ()
void | ags_modular_synth_util_set_env_1_release ()
gdouble | ags_modular_synth_util_get_env_1_gain ()
void | ags_modular_synth_util_set_env_1_gain ()
gdouble | ags_modular_synth_util_get_env_1_frequency ()
void | ags_modular_synth_util_set_env_1_frequency ()
gint64 * | ags_modular_synth_util_get_env_1_sends ()
void | ags_modular_synth_util_set_env_1_sends ()
AgsSynthOscillatorMode | ags_modular_synth_util_get_lfo_0_oscillator ()
void | ags_modular_synth_util_set_lfo_0_oscillator ()
gdouble | ags_modular_synth_util_get_lfo_0_frequency ()
void | ags_modular_synth_util_set_lfo_0_frequency ()
gdouble | ags_modular_synth_util_get_lfo_0_depth ()
void | ags_modular_synth_util_set_lfo_0_depth ()
gdouble | ags_modular_synth_util_get_lfo_0_tuning ()
void | ags_modular_synth_util_set_lfo_0_tuning ()
gint64 * | ags_modular_synth_util_get_lfo_0_sends ()
void | ags_modular_synth_util_set_lfo_0_sends ()
AgsSynthOscillatorMode | ags_modular_synth_util_get_lfo_1_oscillator ()
void | ags_modular_synth_util_set_lfo_1_oscillator ()
gdouble | ags_modular_synth_util_get_lfo_1_frequency ()
void | ags_modular_synth_util_set_lfo_1_frequency ()
gdouble | ags_modular_synth_util_get_lfo_1_depth ()
void | ags_modular_synth_util_set_lfo_1_depth ()
gdouble | ags_modular_synth_util_get_lfo_1_tuning ()
void | ags_modular_synth_util_set_lfo_1_tuning ()
gint64 * | ags_modular_synth_util_get_lfo_1_sends ()
void | ags_modular_synth_util_set_lfo_1_sends ()
gdouble | ags_modular_synth_util_get_noise_frequency ()
void | ags_modular_synth_util_set_noise_frequency ()
gdouble | ags_modular_synth_util_get_noise_gain ()
void | ags_modular_synth_util_set_noise_gain ()
gint64 * | ags_modular_synth_util_get_noise_sends ()
void | ags_modular_synth_util_set_noise_sends ()
guint | ags_modular_synth_util_get_frame_count ()
void | ags_modular_synth_util_set_frame_count ()
guint | ags_modular_synth_util_get_offset ()
void | ags_modular_synth_util_set_offset ()
gboolean | ags_modular_synth_util_get_note_256th_mode ()
void | ags_modular_synth_util_set_note_256th_mode ()
guint | ags_modular_synth_util_get_offset_256th ()
void | ags_modular_synth_util_set_offset_256th ()
void | ags_modular_synth_util_compute_s8 ()
void | ags_modular_synth_util_compute_s16 ()
void | ags_modular_synth_util_compute_s24 ()
void | ags_modular_synth_util_compute_s32 ()
void | ags_modular_synth_util_compute_s64 ()
void | ags_modular_synth_util_compute_float ()
void | ags_modular_synth_util_compute_double ()
void | ags_modular_synth_util_compute_complex ()
void | ags_modular_synth_util_compute ()

## Types and Values

#define | AGS_MODULAR_SYNTH_UTIL_DEFAULT_OSC_OSCILLATOR
#define | AGS_MODULAR_SYNTH_UTIL_DEFAULT_OSC_FREQUENCY
#define | AGS_MODULAR_SYNTH_UTIL_DEFAULT_OSC_PHASE
#define | AGS_MODULAR_SYNTH_UTIL_DEFAULT_OSC_VOLUME
#define | AGS_MODULAR_SYNTH_UTIL_DEFAULT_PITCH_TUNING
#define | AGS_MODULAR_SYNTH_UTIL_DEFAULT_VOLUME
#define | AGS_MODULAR_SYNTH_UTIL_DEFAULT_LFO_OSCILLATOR
#define | AGS_MODULAR_SYNTH_UTIL_DEFAULT_LFO_FREQUENCY
#define | AGS_MODULAR_SYNTH_UTIL_DEFAULT_LFO_DEPTH
#define | AGS_MODULAR_SYNTH_UTIL_DEFAULT_LFO_TUNING
#define | AGS_MODULAR_SYNTH_SENDS_COUNT
#define | AGS_MODULAR_SYNTH_UTIL_INITIALIZER
enum | AgsModularSynthSends

## Object Hierarchy

        GBoxed
        ╰── AgsModularSynthUtil

## Includes

    #include <ags/audio/ags_modular_synth_util.h>

## Description

Utility functions to compute modular synths.

## Functions

### ags_modular_synth_util_alloc ()

    AgsModularSynthUtil *
    ags_modular_synth_util_alloc ();

Allocate AgsModularSynthUtil

#### Returns

a new AgsModularSynthUtil

Since: 8.2.0

### ags_modular_synth_util_copy ()

    gpointer
    ags_modular_synth_util_copy (AgsModularSynthUtil *ptr);

Create a copy of `ptr` .

#### Parameters

ptr | the original AgsModularSynthUtil |

#### Returns

a pointer of the new AgsModularSynthUtil

Since: 8.2.0

### ags_modular_synth_util_free ()

    void
    ags_modular_synth_util_free (AgsModularSynthUtil *ptr);

Free the memory of `ptr` .

#### Parameters

ptr | the AgsModularSynthUtil |

Since: 8.2.0

### ags_modular_synth_util_get_source ()

    gpointer
    ags_modular_synth_util_get_source (AgsModularSynthUtil *modular_synth_util);

Get source buffer of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the source buffer

Since: 8.2.0

### ags_modular_synth_util_set_source ()

    void
    ags_modular_synth_util_set_source (AgsModularSynthUtil *modular_synth_util,
                                       gpointer source);

Set `source` buffer of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
source | the source buffer. | [transfer none]

Since: 8.2.0

### ags_modular_synth_util_get_source_stride ()

    guint
    ags_modular_synth_util_get_source_stride
                                   (AgsModularSynthUtil *modular_synth_util);

Get source stride of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the source buffer stride

Since: 8.2.0

### ags_modular_synth_util_set_source_stride ()

    void
    ags_modular_synth_util_set_source_stride
                                   (AgsModularSynthUtil *modular_synth_util,
                                    guint source_stride);

Set `source` stride of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
source_stride | the source buffer stride |

Since: 8.2.0

### ags_modular_synth_util_get_buffer_length ()

    guint
    ags_modular_synth_util_get_buffer_length
                                   (AgsModularSynthUtil *modular_synth_util);

Get buffer length of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the buffer length

Since: 8.2.0

### ags_modular_synth_util_set_buffer_length ()

    void
    ags_modular_synth_util_set_buffer_length
                                   (AgsModularSynthUtil *modular_synth_util,
                                    guint buffer_length);

Set `buffer_length` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
buffer_length | the buffer length |

Since: 8.2.0

### ags_modular_synth_util_get_format ()

    AgsSoundcardFormat
    ags_modular_synth_util_get_format (AgsModularSynthUtil *modular_synth_util);

Get audio buffer util format of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the audio buffer util format

Since: 8.2.0

### ags_modular_synth_util_set_format ()

    void
    ags_modular_synth_util_set_format (AgsModularSynthUtil *modular_synth_util,
                                       AgsSoundcardFormat format);

Set `format` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
format | the audio buffer util format |

Since: 8.2.0

### ags_modular_synth_util_get_samplerate ()

    guint
    ags_modular_synth_util_get_samplerate (AgsModularSynthUtil *modular_synth_util);

Get samplerate of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the samplerate

Since: 8.2.0

### ags_modular_synth_util_set_samplerate ()

    void
    ags_modular_synth_util_set_samplerate (AgsModularSynthUtil *modular_synth_util,
                                           guint samplerate);

Set `samplerate` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
samplerate | the samplerate |

Since: 8.2.0

### ags_modular_synth_util_get_osc_0_oscillator ()

    AgsSynthOscillatorMode
    ags_modular_synth_util_get_osc_0_oscillator
                                   (AgsModularSynthUtil *modular_synth_util);

Get osc-0 oscillator mode of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the osc-0 oscillator mode as AgsSynthOscillatorMode

Since: 8.2.0

### ags_modular_synth_util_set_osc_0_oscillator ()

    void
    ags_modular_synth_util_set_osc_0_oscillator
                                   (AgsModularSynthUtil *modular_synth_util,
                                    AgsSynthOscillatorMode osc_0_oscillator);

Set `osc_0_oscillator` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
osc_0_oscillator | the osc-0 oscillator mode as AgsSynthOscillatorMode |

Since: 8.2.0

### ags_modular_synth_util_get_osc_0_frequency ()

    gdouble
    ags_modular_synth_util_get_osc_0_frequency
                                   (AgsModularSynthUtil *modular_synth_util);

Get osc-0 frequency of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the osc-0 frequency

Since: 8.2.0

### ags_modular_synth_util_set_osc_0_frequency ()

    void
    ags_modular_synth_util_set_osc_0_frequency
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble osc_0_frequency);

Set `osc_0_frequency` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
osc_0_frequency | the osc-0 frequency |

Since: 8.2.0

### ags_modular_synth_util_get_osc_0_phase ()

    gdouble
    ags_modular_synth_util_get_osc_0_phase
                                   (AgsModularSynthUtil *modular_synth_util);

Get osc-0 phase of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the osc-0 phase

Since: 8.2.0

### ags_modular_synth_util_set_osc_0_phase ()

    void
    ags_modular_synth_util_set_osc_0_phase
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble osc_0_phase);

Set `osc_0_phase` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
osc_0_phase | the osc-0 phase |

Since: 8.2.0

### ags_modular_synth_util_get_osc_0_volume ()

    gdouble
    ags_modular_synth_util_get_osc_0_volume
                                   (AgsModularSynthUtil *modular_synth_util);

Get osc-0 volume of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the osc-0 volume

Since: 8.2.0

### ags_modular_synth_util_set_osc_0_volume ()

    void
    ags_modular_synth_util_set_osc_0_volume
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble osc_0_volume);

Set `osc_0_volume` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
osc_0_volume | the osc-0 volume |

Since: 8.2.0

### ags_modular_synth_util_get_osc_1_oscillator ()

    AgsSynthOscillatorMode
    ags_modular_synth_util_get_osc_1_oscillator
                                   (AgsModularSynthUtil *modular_synth_util);

Get osc-1 oscillator mode of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the osc-1 oscillator mode as AgsSynthOscillatorMode

Since: 8.2.0

### ags_modular_synth_util_set_osc_1_oscillator ()

    void
    ags_modular_synth_util_set_osc_1_oscillator
                                   (AgsModularSynthUtil *modular_synth_util,
                                    AgsSynthOscillatorMode osc_1_oscillator);

Set `osc_1_oscillator` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
osc_1_oscillator | the osc-1 oscillator mode as AgsSynthOscillatorMode |

Since: 8.2.0

### ags_modular_synth_util_get_osc_1_frequency ()

    gdouble
    ags_modular_synth_util_get_osc_1_frequency
                                   (AgsModularSynthUtil *modular_synth_util);

Get osc-1 frequency of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the osc-1 frequency

Since: 8.2.0

### ags_modular_synth_util_set_osc_1_frequency ()

    void
    ags_modular_synth_util_set_osc_1_frequency
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble osc_1_frequency);

Set `osc_1_frequency` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
osc_1_frequency | the osc-1 frequency |

Since: 8.2.0

### ags_modular_synth_util_get_osc_1_phase ()

    gdouble
    ags_modular_synth_util_get_osc_1_phase
                                   (AgsModularSynthUtil *modular_synth_util);

Get osc-1 phase of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the osc-1 phase

Since: 8.2.0

### ags_modular_synth_util_set_osc_1_phase ()

    void
    ags_modular_synth_util_set_osc_1_phase
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble osc_1_phase);

Set `osc_1_phase` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
osc_1_phase | the osc-1 phase |

Since: 8.2.0

### ags_modular_synth_util_get_osc_1_volume ()

    gdouble
    ags_modular_synth_util_get_osc_1_volume
                                   (AgsModularSynthUtil *modular_synth_util);

Get osc-1 volume of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the osc-1 volume

Since: 8.2.0

### ags_modular_synth_util_set_osc_1_volume ()

    void
    ags_modular_synth_util_set_osc_1_volume
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble osc_1_volume);

Set `osc_1_volume` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
osc_1_volume | the osc-1 volume |

Since: 8.2.0

### ags_modular_synth_util_get_pitch_tuning ()

    gdouble
    ags_modular_synth_util_get_pitch_tuning
                                   (AgsModularSynthUtil *modular_synth_util);

Get pitch tuning of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the pitch tuning

Since: 8.2.0

### ags_modular_synth_util_set_pitch_tuning ()

    void
    ags_modular_synth_util_set_pitch_tuning
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble pitch_tuning);

Set `pitch_tuning` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
pitch_tuning | the pitch tuning |

Since: 8.2.0

### ags_modular_synth_util_get_volume ()

    gdouble
    ags_modular_synth_util_get_volume (AgsModularSynthUtil *modular_synth_util);

Get volume of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the volume

Since: 8.2.0

### ags_modular_synth_util_set_volume ()

    void
    ags_modular_synth_util_set_volume (AgsModularSynthUtil *modular_synth_util,
                                       gdouble volume);

Set `volume` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
volume | the volume |

Since: 8.2.0

### ags_modular_synth_util_get_env_0_attack ()

    gdouble
    ags_modular_synth_util_get_env_0_attack
                                   (AgsModularSynthUtil *modular_synth_util);

Get env-0 attack of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the env-0 attack

Since: 8.2.0

### ags_modular_synth_util_set_env_0_attack ()

    void
    ags_modular_synth_util_set_env_0_attack
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble env_0_attack);

Set `env_0_attack` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_0_attack | the env-0 attack |

Since: 8.2.0

### ags_modular_synth_util_get_env_0_sustain ()

    gdouble
    ags_modular_synth_util_get_env_0_sustain
                                   (AgsModularSynthUtil *modular_synth_util);

Get env-0 sustain of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the env-0 sustain

Since: 8.2.0

### ags_modular_synth_util_set_env_0_sustain ()

    void
    ags_modular_synth_util_set_env_0_sustain
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble env_0_sustain);

Set `env_0_sustain` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_0_sustain | the env-0 sustain |

Since: 8.2.0

### ags_modular_synth_util_get_env_0_decay ()

    gdouble
    ags_modular_synth_util_get_env_0_decay
                                   (AgsModularSynthUtil *modular_synth_util);

Get env-0 decay of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the env-0 decay

Since: 8.2.0

### ags_modular_synth_util_set_env_0_decay ()

    void
    ags_modular_synth_util_set_env_0_decay
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble env_0_decay);

Set `env_0_decay` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_0_decay | the env-0 decay |

Since: 8.2.0

### ags_modular_synth_util_get_env_0_release ()

    gdouble
    ags_modular_synth_util_get_env_0_release
                                   (AgsModularSynthUtil *modular_synth_util);

Get env-0 release of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the env-0 release

Since: 8.2.0

### ags_modular_synth_util_set_env_0_release ()

    void
    ags_modular_synth_util_set_env_0_release
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble env_0_release);

Set `env_0_release` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_0_release | the env-0 release |

Since: 8.2.0

### ags_modular_synth_util_get_env_0_gain ()

    gdouble
    ags_modular_synth_util_get_env_0_gain (AgsModularSynthUtil *modular_synth_util);

Get env-0 gain of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the env-0 gain

Since: 8.2.0

### ags_modular_synth_util_set_env_0_gain ()

    void
    ags_modular_synth_util_set_env_0_gain (AgsModularSynthUtil *modular_synth_util,
                                           gdouble env_0_gain);

Set `env_0_gain` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_0_gain | the env-0 gain |

Since: 8.2.0

### ags_modular_synth_util_get_env_0_frequency ()

    gdouble
    ags_modular_synth_util_get_env_0_frequency
                                   (AgsModularSynthUtil *modular_synth_util);

Get env-0 frequency of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the env-0 frequency

Since: 8.2.0

### ags_modular_synth_util_set_env_0_frequency ()

    void
    ags_modular_synth_util_set_env_0_frequency
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble env_0_frequency);

Set `env_0_frequency` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_0_frequency | the env-0 frequency |

Since: 8.2.0

### ags_modular_synth_util_get_env_0_sends ()

    gint64 *
    ags_modular_synth_util_get_env_0_sends
                                   (AgsModularSynthUtil *modular_synth_util,
                                    guint *env_0_sends_count);

Get env-0 sends of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_0_sends_count | return location of the env-0 sends count. | [out]

#### Returns

the env-0 sends.

[transfer none]

Since: 8.2.0

### ags_modular_synth_util_set_env_0_sends ()

    void
    ags_modular_synth_util_set_env_0_sends
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gint64 *env_0_sends,
                                    guint env_0_sends_count);

Set `env_0_sends` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_0_sends | the env-0 sends |
env_0_sends_count | the env-0 sends count |

Since: 8.2.0

### ags_modular_synth_util_get_env_1_attack ()

    gdouble
    ags_modular_synth_util_get_env_1_attack
                                   (AgsModularSynthUtil *modular_synth_util);

Get env-1 attack of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the env-1 attack

Since: 8.2.0

### ags_modular_synth_util_set_env_1_attack ()

    void
    ags_modular_synth_util_set_env_1_attack
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble env_1_attack);

Set `env_1_attack` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_1_attack | the env-1 attack |

Since: 8.2.0

### ags_modular_synth_util_get_env_1_sustain ()

    gdouble
    ags_modular_synth_util_get_env_1_sustain
                                   (AgsModularSynthUtil *modular_synth_util);

Get env-1 sustain of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the env-1 sustain

Since: 8.2.0

### ags_modular_synth_util_set_env_1_sustain ()

    void
    ags_modular_synth_util_set_env_1_sustain
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble env_1_sustain);

Set `env_1_sustain` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_1_sustain | the env-1 sustain |

Since: 8.2.0

### ags_modular_synth_util_get_env_1_decay ()

    gdouble
    ags_modular_synth_util_get_env_1_decay
                                   (AgsModularSynthUtil *modular_synth_util);

Get env-1 decay of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the env-1 decay

Since: 8.2.0

### ags_modular_synth_util_set_env_1_decay ()

    void
    ags_modular_synth_util_set_env_1_decay
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble env_1_decay);

Set `env_1_decay` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_1_decay | the env-1 decay |

Since: 8.2.0

### ags_modular_synth_util_get_env_1_release ()

    gdouble
    ags_modular_synth_util_get_env_1_release
                                   (AgsModularSynthUtil *modular_synth_util);

Get env-1 release of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the env-1 release

Since: 8.2.0

### ags_modular_synth_util_set_env_1_release ()

    void
    ags_modular_synth_util_set_env_1_release
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble env_1_release);

Set `env_1_release` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_1_release | the env-1 release |

Since: 8.2.0

### ags_modular_synth_util_get_env_1_gain ()

    gdouble
    ags_modular_synth_util_get_env_1_gain (AgsModularSynthUtil *modular_synth_util);

Get env-1 gain of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the env-1 gain

Since: 8.2.0

### ags_modular_synth_util_set_env_1_gain ()

    void
    ags_modular_synth_util_set_env_1_gain (AgsModularSynthUtil *modular_synth_util,
                                           gdouble env_1_gain);

Set `env_1_gain` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_1_gain | the env-1 gain |

Since: 8.2.0

### ags_modular_synth_util_get_env_1_frequency ()

    gdouble
    ags_modular_synth_util_get_env_1_frequency
                                   (AgsModularSynthUtil *modular_synth_util);

Get env-1 frequency of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the env-1 frequency

Since: 8.2.0

### ags_modular_synth_util_set_env_1_frequency ()

    void
    ags_modular_synth_util_set_env_1_frequency
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble env_1_frequency);

Set `env_1_frequency` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_1_frequency | the env-1 frequency |

Since: 8.2.0

### ags_modular_synth_util_get_env_1_sends ()

    gint64 *
    ags_modular_synth_util_get_env_1_sends
                                   (AgsModularSynthUtil *modular_synth_util,
                                    guint *env_1_sends_count);

Get env-1 sends of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_1_sends_count | return location of env-1 sends count. | [out]

#### Returns

the env-1 sends.

[transfer none]

Since: 8.2.0

### ags_modular_synth_util_set_env_1_sends ()

    void
    ags_modular_synth_util_set_env_1_sends
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gint64 *env_1_sends,
                                    guint env_1_sends_count);

Set `env_1_sends` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
env_1_sends | the env-1 sends |
env_1_sends_count | the env-1 sends count |

Since: 8.2.0

### ags_modular_synth_util_get_lfo_0_oscillator ()

    AgsSynthOscillatorMode
    ags_modular_synth_util_get_lfo_0_oscillator
                                   (AgsModularSynthUtil *modular_synth_util);

Get lfo-0 oscillator mode of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the lfo-0 oscillator mode as AgsSynthOscillatorMode

Since: 8.2.0

### ags_modular_synth_util_set_lfo_0_oscillator ()

    void
    ags_modular_synth_util_set_lfo_0_oscillator
                                   (AgsModularSynthUtil *modular_synth_util,
                                    AgsSynthOscillatorMode lfo_0_oscillator);

### ags_modular_synth_util_get_lfo_0_frequency ()

    gdouble
    ags_modular_synth_util_get_lfo_0_frequency
                                   (AgsModularSynthUtil *modular_synth_util);

Get lfo-0 frequency of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the lfo-0 frequency

Since: 8.2.0

### ags_modular_synth_util_set_lfo_0_frequency ()

    void
    ags_modular_synth_util_set_lfo_0_frequency
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble lfo_0_frequency);

### ags_modular_synth_util_get_lfo_0_depth ()

    gdouble
    ags_modular_synth_util_get_lfo_0_depth
                                   (AgsModularSynthUtil *modular_synth_util);

Get lfo-0 depth of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the lfo-0 depth

Since: 8.2.0

### ags_modular_synth_util_set_lfo_0_depth ()

    void
    ags_modular_synth_util_set_lfo_0_depth
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble lfo_0_depth);

### ags_modular_synth_util_get_lfo_0_tuning ()

    gdouble
    ags_modular_synth_util_get_lfo_0_tuning
                                   (AgsModularSynthUtil *modular_synth_util);

Get lfo-0 tuning of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the lfo-0 tuning

Since: 8.2.0

### ags_modular_synth_util_set_lfo_0_tuning ()

    void
    ags_modular_synth_util_set_lfo_0_tuning
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble lfo_0_tuning);

### ags_modular_synth_util_get_lfo_0_sends ()

    gint64 *
    ags_modular_synth_util_get_lfo_0_sends
                                   (AgsModularSynthUtil *modular_synth_util,
                                    guint *lfo_0_sends_count);

Get lfo-0 sends of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
lfo_0_sends_count | the return location of lfo-0 sends count. | [out]

#### Returns

the lfo-0 sends.

[transfer none]

Since: 8.2.0

### ags_modular_synth_util_set_lfo_0_sends ()

    void
    ags_modular_synth_util_set_lfo_0_sends
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gint64 *lfo_0_sends,
                                    guint lfo_0_sends_count);

### ags_modular_synth_util_get_lfo_1_oscillator ()

    AgsSynthOscillatorMode
    ags_modular_synth_util_get_lfo_1_oscillator
                                   (AgsModularSynthUtil *modular_synth_util);

Get lfo-1 oscillator mode of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the lfo-1 oscillator mode as AgsSynthOscillatorMode-mode

Since: 8.2.0

### ags_modular_synth_util_set_lfo_1_oscillator ()

    void
    ags_modular_synth_util_set_lfo_1_oscillator
                                   (AgsModularSynthUtil *modular_synth_util,
                                    AgsSynthOscillatorMode lfo_1_oscillator);

### ags_modular_synth_util_get_lfo_1_frequency ()

    gdouble
    ags_modular_synth_util_get_lfo_1_frequency
                                   (AgsModularSynthUtil *modular_synth_util);

Get lfo-1 frequency of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the lfo-1 frequency

Since: 8.2.0

### ags_modular_synth_util_set_lfo_1_frequency ()

    void
    ags_modular_synth_util_set_lfo_1_frequency
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble lfo_1_frequency);

### ags_modular_synth_util_get_lfo_1_depth ()

    gdouble
    ags_modular_synth_util_get_lfo_1_depth
                                   (AgsModularSynthUtil *modular_synth_util);

Get lfo-1 depth of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the lfo-1 depth

Since: 8.2.0

### ags_modular_synth_util_set_lfo_1_depth ()

    void
    ags_modular_synth_util_set_lfo_1_depth
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble lfo_1_depth);

### ags_modular_synth_util_get_lfo_1_tuning ()

    gdouble
    ags_modular_synth_util_get_lfo_1_tuning
                                   (AgsModularSynthUtil *modular_synth_util);

Get lfo-1 tuning of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the lfo-1 tuning

Since: 8.2.0

### ags_modular_synth_util_set_lfo_1_tuning ()

    void
    ags_modular_synth_util_set_lfo_1_tuning
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble lfo_1_tuning);

### ags_modular_synth_util_get_lfo_1_sends ()

    gint64 *
    ags_modular_synth_util_get_lfo_1_sends
                                   (AgsModularSynthUtil *modular_synth_util,
                                    guint *lfo_1_sends_count);

Get lfo-1 sends of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
lfo_1_sends_count | the return location lfo-1 sends count. | [out]

#### Returns

the lfo-1 sends.

[transfer none]

Since: 8.2.0

### ags_modular_synth_util_set_lfo_1_sends ()

    void
    ags_modular_synth_util_set_lfo_1_sends
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gint64 *lfo_1_sends,
                                    guint lfo_1_sends_count);

### ags_modular_synth_util_get_noise_frequency ()

    gdouble
    ags_modular_synth_util_get_noise_frequency
                                   (AgsModularSynthUtil *modular_synth_util);

Get noise frequency of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the noise frequency

Since: 8.2.0

### ags_modular_synth_util_set_noise_frequency ()

    void
    ags_modular_synth_util_set_noise_frequency
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gdouble noise_frequency);

Set `noise_frequency` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
noise_frequency | the noise frequency |

Since: 8.2.0

### ags_modular_synth_util_get_noise_gain ()

    gdouble
    ags_modular_synth_util_get_noise_gain (AgsModularSynthUtil *modular_synth_util);

Get noise gain of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the noise gain

Since: 8.2.0

### ags_modular_synth_util_set_noise_gain ()

    void
    ags_modular_synth_util_set_noise_gain (AgsModularSynthUtil *modular_synth_util,
                                           gdouble noise_gain);

Set `noise_gain` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
noise_gain | the noise gain |

Since: 8.2.0

### ags_modular_synth_util_get_noise_sends ()

    gint64 *
    ags_modular_synth_util_get_noise_sends
                                   (AgsModularSynthUtil *modular_synth_util,
                                    guint *noise_sends_count);

Get noise sends of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
noise_sends_count | return location of noise sends count. | [out]

#### Returns

the noise sends.

[transfer none]

Since: 8.2.0

### ags_modular_synth_util_set_noise_sends ()

    void
    ags_modular_synth_util_set_noise_sends
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gint64 *noise_sends,
                                    guint noise_sends_count);

Set `noise_sends` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
noise_sends | the noise sends |
noise_sends_count | the noise sends count |

Since: 8.2.0

### ags_modular_synth_util_get_frame_count ()

    guint
    ags_modular_synth_util_get_frame_count
                                   (AgsModularSynthUtil *modular_synth_util);

Get frame count of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the frame count

Since: 8.2.0

### ags_modular_synth_util_set_frame_count ()

    void
    ags_modular_synth_util_set_frame_count
                                   (AgsModularSynthUtil *modular_synth_util,
                                    guint frame_count);

Set `frame_count` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
frame_count | the frame count |

Since: 8.2.0

### ags_modular_synth_util_get_offset ()

    guint
    ags_modular_synth_util_get_offset (AgsModularSynthUtil *modular_synth_util);

Get offset of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the offset

Since: 8.2.0

### ags_modular_synth_util_set_offset ()

    void
    ags_modular_synth_util_set_offset (AgsModularSynthUtil *modular_synth_util,
                                       guint offset);

Set `offset` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
offset | the offset |

Since: 8.2.0

### ags_modular_synth_util_get_note_256th_mode ()

    gboolean
    ags_modular_synth_util_get_note_256th_mode
                                   (AgsModularSynthUtil *modular_synth_util);

Get note 256th mode of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

`TRUE` if note 256th mode, otherwise `FALSE`

Since: 8.2.0

### ags_modular_synth_util_set_note_256th_mode ()

    void
    ags_modular_synth_util_set_note_256th_mode
                                   (AgsModularSynthUtil *modular_synth_util,
                                    gboolean note_256th_mode);

Set `note_256th_mode` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
note_256th_mode | the note 256th mode |

Since: 8.2.0

### ags_modular_synth_util_get_offset_256th ()

    guint
    ags_modular_synth_util_get_offset_256th
                                   (AgsModularSynthUtil *modular_synth_util);

Get offset as note 256th of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |

#### Returns

the offset as note 256th

Since: 8.2.0

### ags_modular_synth_util_set_offset_256th ()

    void
    ags_modular_synth_util_set_offset_256th
                                   (AgsModularSynthUtil *modular_synth_util,
                                    guint offset_256th);

Set `offset_256th` of `modular_synth_util` .

#### Parameters

modular_synth_util | the AgsModularSynthUtil |
offset_256th | the offset as note 256th |

Since: 8.2.0

### ags_modular_synth_util_compute_s8 ()

    void
    ags_modular_synth_util_compute_s8 (AgsModularSynthUtil *modular_synth_util);

### ags_modular_synth_util_compute_s16 ()

    void
    ags_modular_synth_util_compute_s16 (AgsModularSynthUtil *modular_synth_util);

### ags_modular_synth_util_compute_s24 ()

    void
    ags_modular_synth_util_compute_s24 (AgsModularSynthUtil *modular_synth_util);

### ags_modular_synth_util_compute_s32 ()

    void
    ags_modular_synth_util_compute_s32 (AgsModularSynthUtil *modular_synth_util);

### ags_modular_synth_util_compute_s64 ()

    void
    ags_modular_synth_util_compute_s64 (AgsModularSynthUtil *modular_synth_util);

### ags_modular_synth_util_compute_float ()

    void
    ags_modular_synth_util_compute_float (AgsModularSynthUtil *modular_synth_util);

### ags_modular_synth_util_compute_double ()

    void
    ags_modular_synth_util_compute_double (AgsModularSynthUtil *modular_synth_util);

### ags_modular_synth_util_compute_complex ()

    void
    ags_modular_synth_util_compute_complex
                                   (AgsModularSynthUtil *modular_synth_util);

### ags_modular_synth_util_compute ()

    void
    ags_modular_synth_util_compute (AgsModularSynthUtil *modular_synth_util);

## Types and Values

### AGS_MODULAR_SYNTH_UTIL_DEFAULT_OSC_OSCILLATOR

    #define AGS_MODULAR_SYNTH_UTIL_DEFAULT_OSC_OSCILLATOR (AGS_SYNTH_OSCILLATOR_SIN)

### AGS_MODULAR_SYNTH_UTIL_DEFAULT_OSC_FREQUENCY

    #define AGS_MODULAR_SYNTH_UTIL_DEFAULT_OSC_FREQUENCY (440.0)

### AGS_MODULAR_SYNTH_UTIL_DEFAULT_OSC_PHASE

    #define AGS_MODULAR_SYNTH_UTIL_DEFAULT_OSC_PHASE (0.0)

### AGS_MODULAR_SYNTH_UTIL_DEFAULT_OSC_VOLUME

    #define AGS_MODULAR_SYNTH_UTIL_DEFAULT_OSC_VOLUME (1.0)

### AGS_MODULAR_SYNTH_UTIL_DEFAULT_PITCH_TUNING

    #define AGS_MODULAR_SYNTH_UTIL_DEFAULT_PITCH_TUNING (0.0)

### AGS_MODULAR_SYNTH_UTIL_DEFAULT_VOLUME

    #define AGS_MODULAR_SYNTH_UTIL_DEFAULT_VOLUME (1.0)

### AGS_MODULAR_SYNTH_UTIL_DEFAULT_LFO_OSCILLATOR

    #define AGS_MODULAR_SYNTH_UTIL_DEFAULT_LFO_OSCILLATOR (AGS_SYNTH_OSCILLATOR_SIN)

### AGS_MODULAR_SYNTH_UTIL_DEFAULT_LFO_FREQUENCY

    #define AGS_MODULAR_SYNTH_UTIL_DEFAULT_LFO_FREQUENCY (6.0)

### AGS_MODULAR_SYNTH_UTIL_DEFAULT_LFO_DEPTH

    #define AGS_MODULAR_SYNTH_UTIL_DEFAULT_LFO_DEPTH (0.0)

### AGS_MODULAR_SYNTH_UTIL_DEFAULT_LFO_TUNING

    #define AGS_MODULAR_SYNTH_UTIL_DEFAULT_LFO_TUNING (0.0)

### AGS_MODULAR_SYNTH_SENDS_COUNT

    #define AGS_MODULAR_SYNTH_SENDS_COUNT (8)

### AGS_MODULAR_SYNTH_UTIL_INITIALIZER

    #define             AGS_MODULAR_SYNTH_UTIL_INITIALIZER

### enum AgsModularSynthSends

#### Members

AGS_MODULAR_SYNTH_SENDS_OSC_0_FREQUENCY |  |
AGS_MODULAR_SYNTH_SENDS_OSC_0_PHASE |  |
AGS_MODULAR_SYNTH_SENDS_OSC_0_VOLUME |  |
AGS_MODULAR_SYNTH_SENDS_OSC_1_FREQUENCY |  |
AGS_MODULAR_SYNTH_SENDS_OSC_1_PHASE |  |
AGS_MODULAR_SYNTH_SENDS_OSC_1_VOLUME |  |
AGS_MODULAR_SYNTH_SENDS_PITCH_TUNING |  |
AGS_MODULAR_SYNTH_SENDS_VOLUME |  |